(function () {
  "use strict";


  window.App = {
    currentScene: null,
    scenes: {},
    isShown: true,
	navigatingFrom: -1,
	
    initialize: function () {
		$("#back_button").hide();
		$$legend.keys.tools("Поиск");
		var o = this;
		var bg = $('.bg');
		this.waitscreen = true;
		this.$connector = new Connector(function(){o.postInitialize();});
		this.$subselect = new SubSelect($(".sub-select")[0], "43px", 15);
		this.$search = new Search($(".search-box")[0]);
		this.$player = new PlayerControl();
		this.$connector.OnUpdatedMenu = function(){o.updateMenu();};
		this.$connector.OnUpdatedContent = function(){o.updateContent();};
		this.$connector.OnPlay = function(c, data){
			o.$player.Play(data.url);
		};
		this.$player.OnPlay = function() {
			bg.hide();
			o.toggleView(false);
		};
		this.$player.OnStop = function() {
			bg.show();
			if(o.isShown)
			{
				$$legend.show();
				$$legend.keys.tools("Поиск");
			}
			o.toggleView(true);
			o.updateLegend();
		};
    },
	
	postInitialize: function () {
		this.$wrap = $('.wrap');
		$$legend.show();
		this.setEvents();
		$$nav.on();
    },

    setEvents: function () {
      var self = this,
        $bg = $('.bg');

      // click on menu item
      $('.menu').on('click', '.menu-item', function ( e ) {
        var swc = e.currentTarget.getAttribute('data-switch');
        var act = e.currentTarget.getAttribute('data-action');
		
		if(act)
		{
			switch(act)
			{
			case "search":
				self.$search.Show(function(q){self.$connector.Search(q)});
				break;
			case "return":
				self.$connector.Return();
				break;
			}
			return;
		}
		switch(swc)
		{
		case "type":
			self.$subselect.Show(self.$connector.ListTypes(), function(id){self.$connector.SelectType(id)});
			break;
		case "country":
			self.$subselect.Show(self.$connector.ListCountries(), function(id){self.$connector.SelectCountry(id)});
			break;
		case "genre":
			self.$subselect.Show(self.$connector.ListGenres(), function(id){self.$connector.SelectGenre(id)});
			break;
		case "sort":
			self.$subselect.Show(self.$connector.ListSorts(), function(id){self.$connector.SelectSort(id)});
			break;
		case "year":
			self.$subselect.Show(self.$connector.ListYears(), function(id){self.$connector.SelectYear(id)});
			break;
		case "rate":
			self.$subselect.Show(self.$connector.ListRates(), function(id){self.$connector.SelectRate(id)});
			break;
		}
      });
	  
	  $(".navigation-item").on('click', function( e ) {
		var nameId = e.currentTarget.getAttribute('name_id');
		self.$connector.Select(nameId);
	  });

      $(document.body).on({
		'nav_key:num': function ( e ) {
			if(!self.isShown || self.$connector.IsNavigating())
				return;
			var type = self.$connector.ContentType();
			if(type != DataType.LIST && type != DataType.SEARCH)
				return;
			var num = parseInt(e.num);
			if(num == NaN)
				return;
			num -= 1;
			if(num < 0)
				num += 10;
			var element = $(".navigation-item")[num];
			if(!$(element).is(":visible"))
				return;
			$$nav.current(element, "page_auto");
			$(element).trigger("click");
        },
		
		'nav_key:return': function ( e ) {
			if(!self.isShown || e.handled)
				return;
			var back_button = $('#back_button');
			if(back_button.is(':visible'))
				back_button.trigger("click");
        },
		
		'nav_key:tools': function ( e ) {
			if(!self.isShown)//show menu
			{
				self.$player.External(true);
				self.toggleView();
				self.updateLegend();
				$$nav.current($("#menu_button_red")[0]);
			}
			else if(self.$player.IsExternal())//hide menu
			{
				self.toggleView();
				self.$player.External(false);
			}
			else//search
			{
				if(self.$connector.IsNavigating())
					return;
				var button = $("#menu_button_search");
				$$nav.current(button[0], "page_auto");
				button.trigger("click");
			}
        },
		
		'nav_key:red': function ( e ) {
			if(!self.isShown)
				return;
			if(self.$connector.IsNavigating())
				return;
			var button = $("#menu_button_red");
			$$nav.current(button[0], "page_auto");
			button.trigger("click");
        },
		
		'nav_key:green': function ( e ) {
			if(!self.isShown)
				return;
			if(self.$connector.IsNavigating())
				return;
			var button = $("#menu_button_green");
			$$nav.current(button[0], "page_auto");
			button.trigger("click");
        },
		
		'nav_key:blue': function ( e ) {
			if(!self.isShown)
				return;
			if(self.$connector.IsNavigating())
				return;
			var button = $("#menu_button_blue");
			$$nav.current(button[0], "page_auto");
			button.trigger("click");
        },
		
		'nav_key:yellow': function ( e ) {
			if(!self.isShown)
				return;
			if(self.$connector.IsNavigating())
				return;
			var button = $("#menu_button_yellow");
			$$nav.current(button[0], "page_auto");
			button.trigger("click");
        },
		
		'nav_key:rew': function( e ) {
			if(!self.isShown)
				return;
			if(self.$connector.ContentType() == DataType.ITEM)
				self.scrollUp();
			else
				self.quickPagingPrev();
			return;
		},
		'nav_key:ff': function( e ) {
			if(!self.isShown)
				return;
			if(self.$connector.ContentType() == DataType.ITEM)
				self.scrollDown();
			else
				self.quickPagingNext();
			return;
		},

        // remote events
        'nav_key:exit': function(){
			self.$player.ForceStop();
			SB.exit();
        }
      });
	  $(".navigation-item").on({
			'nav_key:up': _.bind(this.tryPagingPrev, this),
			'nav_key:down': _.bind(this.tryPagingNext, this)
	  });


    },
	
	tryPagingNext: function (e) {
		if(!this.isShown)
			return;
		var ct = this.$connector.ContentType();
		if(this.$connector.IsNavigating() || (ct != DataType.LIST && ct != DataType.SEARCH))
			return;
		var from = e.target.getAttribute("nav_num");
		if(from == null)
			return;
		from = parseInt(from);
		if(from === NaN)
			return;
		if(from <= 4)
			return;
		if(this.$connector.NextPage())
			this.navigatingFrom = from;
	},
	
	tryPagingPrev: function (e) {
		if(!this.isShown)
			return;
		var ct = this.$connector.ContentType();
		if(this.$connector.IsNavigating() || (ct != DataType.LIST && ct != DataType.SEARCH))
			return;
		var from = e.target.getAttribute("nav_num");
		if(from == null)
			return;
		from = parseInt(from);
		if(from === NaN)
			return;
		if(from > 4)
			return;
		if(this.$connector.PrevPage())
			this.navigatingFrom = from;
	},
	
	quickPagingNext: function () {
		var ct = this.$connector.ContentType();
		if(this.$connector.IsNavigating() || (ct != DataType.LIST && ct != DataType.SEARCH))
			return;
		var navFrom = -1;	
		var e = $(".navigation-item.focus");
		if(e.length > 0)
		{
			var from = e[0].getAttribute("nav_num");
			if(from != null)
			{
				from = parseInt(from);
				if(from !== NaN)
					navFrom = from;
			}
		}
		if(this.$connector.NextPage())
			this.navigatingFrom = navFrom;
	},
	
	quickPagingPrev: function () {
		var ct = this.$connector.ContentType();
		if(this.$connector.IsNavigating() || (ct != DataType.LIST && ct != DataType.SEARCH))
			return;
		var navFrom = -1;	
		var e = $(".navigation-item.focus");
		if(e.length > 0)
		{
			var from = e[0].getAttribute("nav_num");
			if(from != null)
			{
				from = parseInt(from);
				if(from !== NaN)
					navFrom = from;
			}
		}
		if(this.$connector.PrevPage())
			this.navigatingFrom = navFrom;
	},
	
	scrollUp: function() {
		var ct = this.$connector.ContentType();
		if(this.$connector.IsNavigating() || ct != DataType.ITEM)
			return;
		var scroller = $(".item-wrapper");
		var limitter = $(".item-limiter");
		if(!scroller.length || !limitter.length)
			return;
		var scrollerHeight = scroller.height();
		var limitterHeight = limitter.height();
		var maxScroll = scrollerHeight - limitterHeight;
		if(maxScroll <= 0)
			return;
		var scrollPosition = scroller[0].getAttribute("scrollPosition");
		if(scrollPosition === null)
		{
			scrollPosition = 0;
			scroller[0].setAttribute("scrollPosition", 0);
		}
		else
			scrollPosition = parseInt(scrollPosition);
		var newScrollPosition = scrollPosition - limitterHeight;
		if(newScrollPosition < 0)
			newScrollPosition = 0;
		if(scrollPosition == newScrollPosition)
			return;
		scroller[0].setAttribute("scrollPosition", newScrollPosition);
		scroller.css("top", (newScrollPosition ? -newScrollPosition : 0) + "px");
	},
	
	scrollDown: function() {
		var ct = this.$connector.ContentType();
		if(this.$connector.IsNavigating() || ct != DataType.ITEM)
			return;
		var scroller = $(".item-wrapper");
		var limitter = $(".item-limiter");
		if(!scroller.length || !limitter.length)
			return;
		var scrollerHeight = scroller.height();
		var limitterHeight = limitter.height();
		var maxScroll = scrollerHeight - limitterHeight;
		if(maxScroll <= 0)
			return;
		var scrollPosition = scroller[0].getAttribute("scrollPosition");
		if(scrollPosition === null)
		{
			scrollPosition = 0;
			scroller[0].setAttribute("scrollPosition", 0);
		}
		else
			scrollPosition = parseInt(scrollPosition);
		var newScrollPosition = scrollPosition + limitterHeight;
		if(newScrollPosition > maxScroll)
			newScrollPosition = maxScroll;
		if(scrollPosition == newScrollPosition)
			return;
		scroller[0].setAttribute("scrollPosition", newScrollPosition);
		scroller.css("top", (newScrollPosition ? -newScrollPosition : 0) + "px");
	},

    toggleView: function (status) {
		if(status !== undefined)
		{
			if(this.isShown ^ status)
				this.toggleView();
			return;
		}
		if (this.isShown) {
			this.$wrap.hide();
			$$legend.keys.tools("Меню");
			$$legend.hide();
		} else {
			this.$wrap.show();
			$$legend.show();
			if(this.$player.IsExternal())
				$$legend.keys.tools("Продолжить просмотр");
			else
				$$legend.keys.tools("Поиск");
		}
		this.isShown = !this.isShown;
    },
	
	updateMenu: function () {
		$("#type_selected_box")[0].innerHTML = this.$connector.SelectedType();
		$("#country_selected_box")[0].innerHTML = this.$connector.SelectedCountry();
		$("#genre_selected_box")[0].innerHTML = this.$connector.SelectedGenre();
		$("#sort_selected_box")[0].innerHTML = this.$connector.SelectedSort();
		$("#year_selected_box")[0].innerHTML = this.$connector.SelectedYear();
		$("#rate_selected_box")[0].innerHTML = this.$connector.SelectedRate();
	},
	
	updateContent: function () {
		if(this.$player.IsExternal())
			this.$player.ForceStop();
		var type = this.$connector.ContentType();
		switch(type)
		{
			case DataType.NONE:
				$(".scenes-wrapper, .scenes-wrapper .scene-list, .scenes-wrapper .scene-item").hide();
				$("#back_button").hide();
				break;
			case DataType.SEARCH:
				$("#back_button").show();
			case DataType.LIST:
				if(type == DataType.LIST)
					$("#back_button").hide();
				$(".scenes-wrapper, .scenes-wrapper .scene-list").show();
				$(".scenes-wrapper .scene-item").hide();
				var items = this.$connector.Content();
				var blocks = this.renderPage(items, this.$connector.Page(), this.$connector.Pages());
				var select = 0;
				if(items.length > 0)
				{
					if(this.navigatingFrom >= 0)
					{
						select = this.navigatingFrom;
						this.navigatingFrom = -1;
					}
					if(select >= items.length)
						select -= 5;
					if(select < 0 || select >= items.length)
						select = 0;
					$$nav.current(blocks[select], "page_auto");
				}
				break;
			case DataType.ITEM:
				$("#back_button").show();
				$(".scenes-wrapper, .scenes-wrapper .scene-item").show();
				$(".scenes-wrapper .scene-list").hide();
				var item = this.$connector.Content();
				var focus = this.renderItem(item);
				$$nav.current(focus, "page_auto");
				break;
		}
		this.updateLegend();
		if(this.waitscreen)
		{
			this.waitscreen = false;
			$("body")[0].removeChild($(".waitscreen")[0]);
		}
	},
	
	updateLegend: function () {
		var type = this.$connector.ContentType();
		switch(type)
		{
			case DataType.NONE:
				$$legend.keys.ret("");
				$$legend.keys.rew("");
				$$legend.keys.ff("");
				$$legend.keys.number("");
				break;
			case DataType.SEARCH:
				$$legend.keys.ret("Назад");
			case DataType.LIST:
				if(type == DataType.LIST)
					$$legend.keys.ret("");
				$$legend.keys.rew("Предидущая страница");
				$$legend.keys.ff("Следующая страница");
				$$legend.keys.number("Выбрать");
				break;
			case DataType.ITEM:
				$$legend.keys.ret("Назад");
				$$legend.keys.rew("Прокрутка вверх");
				$$legend.keys.ff("Прокрутка вниз");
				$$legend.keys.number("");
				break;
		}
	},
	
	renderItem: function (item) {
		var o = this;
		var block = $(".scene-item")[0];
		while(block.childNodes.length > 0)
			block.removeChild(block.childNodes[0]);
		if(item == null)
			return this.renderNotFound(block);
		var limiter = document.createElement("div");
		limiter.className = "item-limiter";
		limiter = block.appendChild(limiter);
		var wrapper = document.createElement("div");
		wrapper.className = "item-wrapper";
		wrapper = limiter.appendChild(wrapper);
		
		var image = document.createElement("img");
		image.className = "item-image-big";
		image.src = item.image_url;
		wrapper.appendChild(image);
		
		var title = document.createElement("h2");
		title.className = "item-title";
		title.innerHTML = item.name_rus;
		wrapper.appendChild(title);
		
		if(item.name_original)
		{
			var titleOrig = document.createElement("div");
			titleOrig.className = "item-title-original";
			titleOrig.innerHTML = item.name_original;
			wrapper.appendChild(titleOrig);
		}
		
		var lineBlock;
		var bTitle;
		var bContent;
		
		if(item.rating_kinopoisk !== undefined || item.rating_imdb !== undefined)
		{
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "Рейтинг";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent = lineBlock.appendChild(bContent);
			if(item.rating_kinopoisk !== undefined)
			{
				var ratingKp = document.createElement("span");
				ratingKp.className = "rating-kinopoisk";
				ratingKp.innerHTML = "" + (Math.round(item.rating_kinopoisk * 10) / 10);
				bContent.appendChild(ratingKp);
			}
			if(item.rating_imdb !== undefined)
			{
				var ratingImdb = document.createElement("span");
				ratingImdb.className = "rating-imdb";
				ratingImdb.innerHTML = "" + (Math.round(item.rating_imdb * 10) / 10);
				bContent.appendChild(ratingImdb);
			}
		}
		
		lineBlock = document.createElement("div");
		lineBlock.className = "line-block";
		lineBlock = wrapper.appendChild(lineBlock);
		bTitle = document.createElement("div");
		bTitle.className = "line-block-title";
		bTitle.innerHTML = "Жанры";
		lineBlock.appendChild(bTitle);
		bContent = document.createElement("div");
		bContent.className = "line-block-content";
		bContent.innerHTML = item.genre;
		lineBlock.appendChild(bContent);
		
		var yearString = "" + item.year;
		if(item.serial)
		{
			if(item.serial_ended)
			{
				if(item.serial_end_year != item.year)
					yearString += " - " + item.serial_end_year;
			}
			else
				yearString += "...";
		}
		lineBlock = document.createElement("div");
		lineBlock.className = "line-block";
		lineBlock = wrapper.appendChild(lineBlock);
		bTitle = document.createElement("div");
		bTitle.className = "line-block-title";
		bTitle.innerHTML = "Год";
		lineBlock.appendChild(bTitle);
		bContent = document.createElement("div");
		bContent.className = "line-block-content";
		bContent.innerHTML = yearString;
		lineBlock.appendChild(bContent);
		
		lineBlock = document.createElement("div");
		lineBlock.className = "line-block";
		lineBlock = wrapper.appendChild(lineBlock);
		bTitle = document.createElement("div");
		bTitle.className = "line-block-title";
		bTitle.innerHTML = "Страна";
		lineBlock.appendChild(bTitle);
		bContent = document.createElement("div");
		bContent.className = "line-block-content";
		bContent.innerHTML = item.country;
		lineBlock.appendChild(bContent);
		
		if(item.regis)
		{
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "Режиссёр";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent.innerHTML = item.regis;
			lineBlock.appendChild(bContent);
		}
		
		if(item.scene)
		{
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "Сценарий";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent.innerHTML = item.scene;
			lineBlock.appendChild(bContent);
		}
		
		if(item.runtime)
		{
			var length = "";
			if(item.runtime.hours)
			{
				var v = item.runtime.hours;
				length += v + " ";
				v %= 100;
				if(v >= 11 && v < 20)
					v = 0;
				v %= 10;
				if(v == 0 || v >= 5)
					length += "часов";
				else if(v == 1)
					length += "час";
				else
					length += "часа";
			}
			if(item.runtime.minutes)
			{
				var v = item.runtime.minutes;
				if(length)
					length += ", ";
				length += v + " ";
				v %= 100;
				if(v >= 11 && v < 20)
					v = 0;
				v %= 10;
				if(v == 0 || v >= 5)
					length += "минут";
				else if(v == 1)
					length += "минута";
				else
					length += "минуты";
			}
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "Длительность";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent.innerHTML = length;
			lineBlock.appendChild(bContent);
		}
		
		var actorsBlock = document.createElement("div");
		actorsBlock.className = "actors-block";
		actorsBlock = wrapper.appendChild(actorsBlock);
		for(var i = 0; i < item.actor.length; i++)
		{
			var actorBlock = document.createElement("div");
			actorBlock.className = "actor-block";
			actorBlock = actorsBlock.appendChild(actorBlock);
			var photo = document.createElement("img");
			photo.className = "actor-photo";
			photo.onerror = function(){this.src = "img/nophoto.png"};
			photo.src = item.actor[i].image;
			actorBlock.appendChild(photo);
			var name = document.createElement("span");
			name.className = "actor-name";
			name.innerHTML = item.actor[i].name;
			actorBlock.appendChild(name);
		}
		
		var descriptionBlock = document.createElement("div");
		descriptionBlock.className = "item-description";
		descriptionBlock.innerHTML = item.description;
		wrapper.appendChild(descriptionBlock);
		
		if((!item.serial || !item.seasons.length) && item.mobi_link_id)
		{
			$(block).toggleClass("serial", false);
			var playButton = document.createElement("div");
			playButton.className = "play-button nav-item";
			playButton.innerHTML = "Посмотреть";
			playButton = block.appendChild(playButton);
			(function() {
				var filmId = item.mobi_link_id;
				$(playButton).on("click", function () {
					o.$connector.Play(filmId);
				});
			})();
			return playButton;
		}
		
		if(!item.seasons || !item.seasons.length)
		{
			$(block).toggleClass("serial", false);
			return $("#back_button")[0];
		}
		
		$(block).toggleClass("serial", true);
		
		var seasonsWrapper = document.createElement("div");
		seasonsWrapper.className = "seasons-wrapper";
		block.appendChild(seasonsWrapper);
		
		var label = document.createElement("div");
		label.className = "seasons_label";
		label.innerHTML = "Сезоны";
		seasonsWrapper.appendChild(label);
		
		var seasonsContainer = document.createElement("div");
		seasonsContainer.className = "seasons_container";
		seasonsContainer.setAttribute("data-nav_type", "hbox");
		seasonsContainer.setAttribute("data-nav_loop", "false");
		seasonsContainer = seasonsWrapper.appendChild(seasonsContainer);
		
		var episodesWrapper = document.createElement("div");
		episodesWrapper.className = "episodes-wrapper";
		block.appendChild(episodesWrapper);
		
		label = document.createElement("div");
		label.className = "episodes_label";
		label.innerHTML = "Серии";
		episodesWrapper.appendChild(label);
		
		var episodesContainer = document.createElement("div");
		episodesContainer.className = "episodes_container";
		episodesContainer.setAttribute("data-nav_type", "hbox");
		episodesContainer.setAttribute("data-nav_loop", "false");
		episodesContainer = episodesWrapper.appendChild(episodesContainer);
		
		var firstBlock = null;
		for(var i = 0; i < item.seasons.length; i++)
		{
			(function () {
				var episodes = item.seasons[i].episodes;
				var seasonBlock = document.createElement("div");
				seasonBlock.className = "nav_season nav-item";
				seasonBlock.innerHTML = "" + item.seasons[i].season;
				seasonBlock = seasonsContainer.appendChild(seasonBlock);
				$$nav.current(seasonBlock);
				$(seasonBlock).on("nav_focus", function( e ) { //render episodes
					$(".nav_season.selected").toggleClass("selected", false);
					$(e.currentTarget).toggleClass("selected", true);
					while(episodesContainer.childNodes.length > 0)
						episodesContainer.removeChild(episodesContainer.childNodes[0]);
					for(var i = 0; i < episodes.length; i++)
					{
						(function () {
							var episodeId = episodes[i].linkId;
							var episodeBlock = document.createElement("div");
							episodeBlock.className = "nav_episode nav-item";
							episodeBlock.innerHTML = "" + episodes[i].episode;
							episodesContainer.appendChild(episodeBlock);
							$(episodeBlock).on("click", function(e) {
								o.$connector.Play(episodeId);
							});
						})();
					}
					
				}).on("click", function( e ) {
					$$nav.current(episodesContainer.childNodes[0], "auto");
				});
				if(firstBlock == null)
					firstBlock = seasonBlock;
			})();
		}
		return firstBlock;
	},
	
	renderNotFound: function (block) {
		var message = document.createElement("h2");
		message.className = "item-not-found";
		message.innerHTML = "Объект не найден";
		block.appendChild(message);
		return $("#back_button")[0];
	},
	
	renderPage: function (items, pageNum, pageCount) {
		var i;
		var blocks = $(".navigation-items .navigation-item");
		for(i = 0; i < items.length && i < blocks.length; i++)
		{
			if(items[i].serial)
				this.renderSerial(items[i], blocks[i], i);
			else
				this.renderFilm(items[i], blocks[i], i);
			$(blocks[i]).show();
		}
		for(;i < blocks.length;i++)
			$(blocks[i]).hide();
		$(".navigation-info")[0].innerHTML = "Страница " + pageNum + " из " + pageCount;
		return blocks;
	},
	
	renderFilm: function (item, block, num) {
		this.renderBase(item, block, num);
		var yearBlock = document.createElement("div");
		yearBlock.className = "film_nav_year";
		yearBlock.innerHTML = "" + item.year;
		block.appendChild(yearBlock);
	},
	
	renderSerial: function (item, block, num) {
		this.renderBase(item, block, num);
		var yearString = "" + item.year;
		if(item.serial_ended)
		{
			if(item.serial_end_year != item.year)
				yearString += " - " + item.serial_end_year;
		}
		else
			yearString += "...";
		var yearBlock = document.createElement("div");
		yearBlock.className = "film_nav_year";
		yearBlock.innerHTML = yearString;
		block.appendChild(yearBlock);
	},
	
	renderBase: function (item, block, num) {
		while(block.childNodes.length > 0)
			block.removeChild(block.childNodes[0]);
		//block clear...
		block.setAttribute("name_id", item.name_id);
		block.setAttribute("nav_num", num);
		
		var imgBlock = document.createElement("img");
		imgBlock.className = "film_nav_img";
		imgBlock.src = item.image_url;
		block.appendChild(imgBlock);
		
		var numBlock = document.createElement("div");
		numBlock.className = "film_nav_num";
		numBlock.innerHTML = "" + ((num + 1) % 10);
		block.appendChild(numBlock);
		
		var dataBlock = document.createElement("div");
		dataBlock.className = "film_nav_data";
		dataBlock = block.appendChild(dataBlock);
		
		var nameBlock = document.createElement("div");
		nameBlock.className = "film_nav_name";
		nameBlock.innerHTML = item.name_rus;
		dataBlock.appendChild(nameBlock);
		
		dataBlock.appendChild(document.createElement("br"));
		//dataBlock.appendChild(document.createTextNode(" "));
		
		var genreBlock = document.createElement("div");
		genreBlock.className = "film_nav_genre";
		genreBlock.innerHTML = item.genre;
		dataBlock.appendChild(genreBlock);
		
		var rateBlock = document.createElement("div");
		rateBlock.className = "film_nav_rate";
		rateBlock.innerHTML = "" + (Math.round(item.rating * 10) / 10);
		block.appendChild(rateBlock);
	},

    showContent: function ( scene ) {
      var cur = this.currentScene,
        newScene = this.scenes[scene];

      if ( cur !== newScene ) {
        if ( !newScene ) {
          $$error('Scene ' + scene + ' doesn\'t exist');
        } else {
          if ( cur ) {
            cur.hide();
          }
          newScene.show();
          this.currentScene = newScene;
        }
      }
    }
  };

  // main app initialize when smartbox ready
  SB(_.bind(App.initialize, App));
})();