function SubSelect(container, elementSize, elementsCount){
	var o = this;
	$(container).hide();
	this.$wrapper = container;
	
	var sizePattern = /(\d+)((?:px|%|pt)?)/;
	elementSize = sizePattern.exec(elementSize);
	this.$elementSize = parseInt(elementSize[1]);
	this.$elementSizeUnits = elementSize[2];
	this.$elementsCount = elementsCount;
	this.$elements = [];
	this.$selected = 0;
	this.$scrolled = 0;
	this.$active = false;
	

	this.$arrowUp = document.createElement("div");
	this.$arrowUp.className = "arrow-up";
	this.$arrowUp = container.appendChild(this.$arrowUp);
	
	this.$arrowDown = document.createElement("div");
	this.$arrowDown.className = "arrow-down";
	this.$arrowDown = container.appendChild(this.$arrowDown);
	
	this.$limiter = document.createElement("div");
	this.$limiter.className = "sub-select-limiter";
	this.$limiter = container.appendChild(this.$limiter);
	
	this.$container = document.createElement("div");
	this.$container.className = "sub-items";
	this.$container.setAttribute("data-nav_type", "vbox");
	this.$container.setAttribute("data-nav_loop", "true");
	this.$container = this.$limiter.appendChild(this.$container);
	
	$([this.$arrowUp, this.$arrowDown]).on("mouseover", function(){
			$(this).addClass("focus");
		}).on("mouseout", function(){
			$(this).removeClass("focus");
		});
		
	$(this.$arrowUp).on("click", function(){
		o.ScrollTo(o.$scrolled - o.$elementsCount);
	});
	
	$(this.$arrowDown).on("click", function(){
		o.ScrollTo(o.$scrolled + o.$elementsCount);
	});
		
	$(this.$container).on("nav_key:left", function(e) {
		e.stopPropagation();
		o.Hide();
	});
		
	this.Hide = function() {
		if(!this.$active)
			return;
		this.$active = false;
		$(this.$wrapper).hide();
		while(this.$elements.length > 0)
		{
			var item = this.$elements.pop();
			this.$container.removeChild(item);
		}
		$(this.$container).css("top", 0 + this.$elementSizeUnits);
		this.$selected = 0;
		this.$scrolled = 0;
		$$nav.restore();
	};
	
	this.Focus = function(id)
	{
		this.$selected = id;
		var minVisible = this.$scrolled;
		var maxVisible = minVisible + this.$elementsCount - 1;
		if(id < minVisible)
			this.ScrollTo(id);
		else if(id > maxVisible)
			this.ScrollTo(id - this.$elementsCount + 1);
	};
	
	this.ScrollTo = function(id)
	{
		var maxScroll = this.$elements.length - this.$elementsCount;
		if(maxScroll < 0)
			maxScroll = 0;
		if(id < 0)
			id = 0;
		else if(id > maxScroll)
			id = maxScroll;
		if(id == this.$scrolled)
			return;
		this.$scrolled = id;
		id *= -this.$elementSize;
		$(this.$container).css("top", id + this.$elementSizeUnits);
		this.UpdateArrows();
	};
	
	this.UpdateArrows = function()
	{
		var maxScroll = this.$elements.length - this.$elementsCount;
		if(maxScroll < 0)
			maxScroll = 0;
		var up = this.$scrolled > 0;
		var dn = this.$scrolled < maxScroll;
		$(this.$arrowUp).toggleClass("enabled", up);
		$(this.$arrowDown).toggleClass("enabled", dn);
	}
}

SubSelect.prototype.Show = function(items, callback)
{
	if(this.$active)
		this.Hide();
	this.$active = true;
	var o = this;
	for(var i = 0; i < items.length; i++)
	{
		var item = document.createElement("div");
		item.innerHTML = items[i];
		item.className = "sub-select-item nav-item";
		item.setAttribute("sub-select-id", i);
		item = this.$container.appendChild(item);
		$(item).on("nav_focus", function()
			{
				o.Focus(parseInt(this.getAttribute("sub-select-id")));
			}).on("click nav_key:right", function(e)
			{
				e.stopPropagation();
				var id = parseInt(this.getAttribute("sub-select-id"));
				o.Hide();
				callback(id);
			});
		this.$elements.push(item);
	}
	$(this.$wrapper).show();
	this.UpdateArrows();
	$$nav.save();
	$$nav.on(this.$container);
}

